
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ShiftsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const shifts = await db.shifts.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        timeIn: data.timeIn
        ||
        null
            ,
            
        timeOut: data.timeOut
        ||
        null
            ,
            
        breakDurationMinutes: data.breakDurationMinutes
        ||
        null
            ,
            
        totalWorkingHours: data.totalWorkingHours
        ||
        null
            ,
            
        isRotating: data.isRotating
        ||
        false
        
            ,
            
        rotationCycleDays: data.rotationCycleDays
        ||
        null
            ,
            
        isActive: data.isActive
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        

        

        return shifts;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const shiftsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                timeIn: item.timeIn
            ||
            null
            ,
            
                timeOut: item.timeOut
            ||
            null
            ,
            
                breakDurationMinutes: item.breakDurationMinutes
            ||
            null
            ,
            
                totalWorkingHours: item.totalWorkingHours
            ||
            null
            ,
            
                isRotating: item.isRotating
            ||
            false
        
            ,
            
                rotationCycleDays: item.rotationCycleDays
            ||
            null
            ,
            
                isActive: item.isActive
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const shifts = await db.shifts.bulkCreate(shiftsData, { transaction });

        // For each item created, replace relation files
        

        return shifts;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const shifts = await db.shifts.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.timeIn !== undefined) updatePayload.timeIn = data.timeIn;
        
        
        if (data.timeOut !== undefined) updatePayload.timeOut = data.timeOut;
        
        
        if (data.breakDurationMinutes !== undefined) updatePayload.breakDurationMinutes = data.breakDurationMinutes;
        
        
        if (data.totalWorkingHours !== undefined) updatePayload.totalWorkingHours = data.totalWorkingHours;
        
        
        if (data.isRotating !== undefined) updatePayload.isRotating = data.isRotating;
        
        
        if (data.rotationCycleDays !== undefined) updatePayload.rotationCycleDays = data.rotationCycleDays;
        
        
        if (data.isActive !== undefined) updatePayload.isActive = data.isActive;
        
        
        updatePayload.updatedById = currentUser.id;

        await shifts.update(updatePayload, {transaction});

        
        

        
        

        

        return shifts;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const shifts = await db.shifts.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of shifts) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of shifts) {
                await record.destroy({transaction});
            }
        });


        return shifts;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const shifts = await db.shifts.findByPk(id, options);

        await shifts.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await shifts.destroy({
            transaction
        });

        return shifts;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const shifts = await db.shifts.findOne(
            { where },
            { transaction },
        );

        if (!shifts) {
            return shifts;
        }

        const output = shifts.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        output.employees_shift = await shifts.getEmployees_shift({
            transaction
        });
        
        
        
        output.time_records_shift = await shifts.getTime_records_shift({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'shifts',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.timeIn) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'shifts',
                        'timeIn',
                        filter.timeIn,
                    ),
                };
            }
            
            if (filter.timeOut) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'shifts',
                        'timeOut',
                        filter.timeOut,
                    ),
                };
            }
            

            
            

            
            if (filter.breakDurationMinutesRange) {
                const [start, end] = filter.breakDurationMinutesRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    breakDurationMinutes: {
                    ...where.breakDurationMinutes,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    breakDurationMinutes: {
                    ...where.breakDurationMinutes,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.totalWorkingHoursRange) {
                const [start, end] = filter.totalWorkingHoursRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    totalWorkingHours: {
                    ...where.totalWorkingHours,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    totalWorkingHours: {
                    ...where.totalWorkingHours,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.rotationCycleDaysRange) {
                const [start, end] = filter.rotationCycleDaysRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    rotationCycleDays: {
                    ...where.rotationCycleDays,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    rotationCycleDays: {
                    ...where.rotationCycleDays,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.isRotating) {
                where = {
                    ...where,
                isRotating: filter.isRotating,
            };
            }
            
            if (filter.isActive) {
                where = {
                    ...where,
                isActive: filter.isActive,
            };
            }
            




            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.shifts.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'shifts',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.shifts.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

